﻿using System.Windows.Forms;
using HeuristicLab.Core.Views;
using HeuristicLab.Data;
using HeuristicLab.MainForm;

namespace HeuristicLab.Encodings.ParameterConfigurationEncoding.Views {
  /// <summary>
  /// The visual representation of a <see cref="IRange"/>.
  /// </summary>
  [View("Range View")]
  [Content(typeof(IRange<>), false)]
  public partial class RangeView : ItemView {
    /// <summary>
    /// Gets or sets the variable to represent visually.
    /// </summary>
    public new IRange Content {
      get { return (IRange)base.Content; }
      set { base.Content = value; }
    }

    public RangeView() {
      InitializeComponent();
    }

    protected override void RegisterContentEvents() {
      base.RegisterContentEvents();
    }

    protected override void DeregisterContentEvents() {
      base.DeregisterContentEvents();
    }

    protected override void OnContentChanged() {
      base.OnContentChanged();
      if (Content != null) {
        lowerValueView.Content = (IStringConvertibleValue)Content.LowerBound;
        upperValueView.Content = (IStringConvertibleValue)Content.UpperBound;
        stepSizeValueView.Content = (IStringConvertibleValue)Content.StepSize;
      } else {
        lowerValueView.Content = null;
        upperValueView.Content = null;
        stepSizeValueView.Content = null;
      }
    }

    protected override void SetEnabledStateOfControls() {
      base.SetEnabledStateOfControls();
    }
  }
}
